> ## Documentation Index
> Fetch the complete documentation index at: https://docs.kukkingu.software/llms.txt
> Use this file to discover all available pages before exploring further.

# Partially update billable

> Partially updates an existing billable by its ID.



## OpenAPI

````yaml https://api.contracting.kukkingu.software/api/v1/docs.json patch /api/v1/billables/{billableId}
openapi: 3.1.0
info:
  title: Contracting Backend API
  version: 0.1.0
  description: API documentation for the Contracting backend service.
servers:
  - url: https://api.contracting.kukkingu.software
    description: API server
security:
  - bearerAuth: []
paths:
  /api/v1/billables/{billableId}:
    patch:
      tags:
        - Billables
      summary: Partially update billable
      description: Partially updates an existing billable by its ID.
      parameters:
        - schema:
            type: string
            description: Unique identifier of the billable.
            example: bil_eym9hcqlh1m7v3d36blf0vfx
          in: path
          name: billableId
          required: true
          description: Unique identifier of the billable.
        - schema:
            type: string
            example: tnt_pfh0haxfpzowht3oi213cqos
            description: >-
              Specifies the tenant context for the request. All endpoints
              operate within this tenant scope.
          in: header
          name: tenant-id
          required: true
          description: >-
            Specifies the tenant context for the request. All endpoints operate
            within this tenant scope.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                referenceType:
                  description: >-
                    Optional Billable Reference Type of the external system
                    (e.g. JIRA, Github, etc.).
                  example: JIRA
                  type: string
                referenceId:
                  description: Optional Billable Reference ID in the external system.
                  example: PROJ-123
                  type: string
                description:
                  type: string
                  description: Description of the billable.
                  example: Monthly subscription for service X.
                metadata:
                  description: Optional metadata associated with the billable.
                  example:
                    project: Alpha
                    priority: High
                  type: object
                  properties: {}
                  additionalProperties: {}
                quantity:
                  type: number
                  minimum: 0
                  description: Quantity of items.
                  example: 10
                amountMinor:
                  type: integer
                  minimum: 0
                  maximum: 9007199254740991
                  description: Amount expressed in the minor unit (e.g., cents).
                  example: 5000
                currencyCode:
                  type: string
                  minLength: 3
                  maxLength: 3
                  description: ISO 4217 currency code.
                  example: EUR
                order:
                  type: integer
                  minimum: 0
                  maximum: 9007199254740991
                  description: Order of the resource for sorting purposes.
                  example: 13
              additionalProperties: false
              description: >-
                Request body used to partially update an existing billable
                resource.
        description: Request body used to partially update an existing billable resource.
      responses:
        '200':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: object
                    properties:
                      id:
                        type: string
                        description: Unique identifier of the billable.
                        example: bil_eym9hcqlh1m7v3d36blf0vfx
                      invoice:
                        anyOf:
                          - type: string
                            description: The ID of the invoice.
                            examples:
                              - inv_mqxd1kc6bgtcc676xoqzax47
                          - type: object
                            properties:
                              id:
                                type: string
                                description: The ID of the invoice.
                                examples:
                                  - inv_mqxd1kc6bgtcc676xoqzax47
                              contract:
                                anyOf:
                                  - type: string
                                    description: The ID of the contract.
                                    example: ctr_z23aoo8naxk68ewcr64tchh5
                                  - type: object
                                    properties:
                                      id:
                                        type: string
                                        description: The ID of the contract.
                                        example: ctr_z23aoo8naxk68ewcr64tchh5
                                      client:
                                        anyOf:
                                          - type: string
                                            description: Unique identifier of the client.
                                            example: clnt_z2b3mo8qa5kzptgsu26q2wmh
                                          - type: object
                                            properties:
                                              id:
                                                type: string
                                                description: Unique identifier of the client.
                                                example: clnt_z2b3mo8qa5kzptgsu26q2wmh
                                              name:
                                                type: string
                                                minLength: 1
                                                maxLength: 255
                                                description: The name of the client.
                                                example: Acme Corporation
                                              description:
                                                type: string
                                                maxLength: 1024
                                                description: >-
                                                  Additional information describing the
                                                  client.
                                                example: >-
                                                  A leading provider of road runner
                                                  deterrents.
                                              order:
                                                type: integer
                                                minimum: 0
                                                maximum: 9007199254740991
                                                description: >-
                                                  Order of the resource for sorting
                                                  purposes.
                                                example: 13
                                              createdAt:
                                                type: string
                                                format: date-time
                                                pattern: >-
                                                  ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                                description: Timestamp when the client was created.
                                                example: '2023-10-05T14:48:00.000Z'
                                              updatedAt:
                                                type: string
                                                format: date-time
                                                pattern: >-
                                                  ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                                description: >-
                                                  Timestamp when the client was last
                                                  updated.
                                                example: '2023-10-05T14:48:00.000Z'
                                            required:
                                              - id
                                              - name
                                              - createdAt
                                              - updatedAt
                                            additionalProperties: false
                                            description: Client resource returned by the API.
                                        description: >-
                                          Expandable Client field represented
                                          either as an ID or a fully expanded
                                          object.
                                      name:
                                        type: string
                                        minLength: 1
                                        maxLength: 255
                                        description: Contract name.
                                        example: Standard Service Contract
                                      description:
                                        type: string
                                        description: Detailed contract description.
                                        example: >-
                                          This contract covers standard service
                                          terms and conditions.
                                      amountMinor:
                                        type: integer
                                        minimum: 0
                                        maximum: 9007199254740991
                                        description: >-
                                          Monetary amount in minor units (e.g.,
                                          cents).
                                        example: 5000
                                      currencyCode:
                                        type: string
                                        minLength: 3
                                        maxLength: 3
                                        description: ISO 4217 currency code.
                                        example: EUR
                                      order:
                                        type: integer
                                        minimum: 0
                                        maximum: 9007199254740991
                                        description: >-
                                          Order of the resource for sorting
                                          purposes.
                                        example: 13
                                      validFrom:
                                        type: string
                                        format: date-time
                                        pattern: >-
                                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                        description: Contract validity start date.
                                        example: '2023-10-05T14:48:00.000Z'
                                      validTo:
                                        type: string
                                        format: date-time
                                        pattern: >-
                                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                        description: Contract validity end date.
                                        example: '2023-10-05T14:48:00.000Z'
                                      createdAt:
                                        type: string
                                        format: date-time
                                        pattern: >-
                                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                        description: Timestamp when the contract was created.
                                        example: '2023-10-05T14:48:00.000Z'
                                      updatedAt:
                                        type: string
                                        format: date-time
                                        pattern: >-
                                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                        description: >-
                                          Timestamp when the contract was last
                                          updated.
                                        example: '2023-10-05T14:48:00.000Z'
                                    required:
                                      - id
                                      - client
                                      - name
                                      - amountMinor
                                      - currencyCode
                                      - createdAt
                                      - updatedAt
                                    additionalProperties: false
                                    description: Contract resource returned by the API.
                                description: >-
                                  Expandable Contract field represented either
                                  as an ID or a fully expanded object.
                              status:
                                type: string
                                enum:
                                  - DRAFT
                                  - FINALIZED
                                  - VOID
                                description: Status of the invoice.
                                example: FINALIZED
                              invoiceNumber:
                                type: string
                                minLength: 1
                                maxLength: 255
                                description: Unique invoice number.
                                example: INV-2025-0001
                              exchangeRate:
                                type: number
                                minimum: 0
                                description: >-
                                  Exchange rate applied when currency conversion
                                  is needed.
                                example: 1.12
                              currencyCode:
                                type: string
                                minLength: 3
                                maxLength: 3
                                description: ISO 4217 currency code.
                                example: EUR
                              amountMinor:
                                type: integer
                                minimum: 0
                                maximum: 9007199254740991
                                description: >-
                                  Amount expressed in the minor unit (e.g.,
                                  cents).
                                example: 5000
                              issuedAt:
                                anyOf:
                                  - type: string
                                    format: date-time
                                    pattern: >-
                                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                    description: When the invoice was issued.
                                    example: '2023-10-05T14:48:00.000Z'
                                  - type: 'null'
                              dueAt:
                                anyOf:
                                  - type: string
                                    format: date-time
                                    pattern: >-
                                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                    description: When the invoice is due.
                                    example: '2023-10-05T14:48:00.000Z'
                                  - type: 'null'
                              paidAt:
                                anyOf:
                                  - type: string
                                    format: date-time
                                    pattern: >-
                                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                    description: When the invoice was paid.
                                    example: '2023-10-05T14:48:00.000Z'
                                  - type: 'null'
                              createdAt:
                                type: string
                                format: date-time
                                pattern: >-
                                  ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                description: Timestamp when the invoice was created.
                                example: '2023-10-05T14:48:00.000Z'
                              updatedAt:
                                type: string
                                format: date-time
                                pattern: >-
                                  ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                description: Timestamp when the invoice was last updated.
                                example: '2023-10-05T14:48:00.000Z'
                            required:
                              - id
                              - contract
                              - status
                              - invoiceNumber
                              - exchangeRate
                              - currencyCode
                              - amountMinor
                              - createdAt
                              - updatedAt
                            additionalProperties: false
                            description: Invoice resource returned by the API.
                        description: >-
                          Expandable Invoice field represented either as an ID
                          or a fully expanded object.
                      referenceType:
                        description: >-
                          Optional Billable Reference Type of the external
                          system (e.g. JIRA, Github, etc.).
                        example: JIRA
                        type: string
                      referenceId:
                        description: Optional Billable Reference ID in the external system.
                        example: PROJ-123
                        type: string
                      description:
                        type: string
                        description: Description of the billable.
                        example: Monthly subscription for service X.
                      metadata:
                        description: Optional metadata associated with the billable.
                        example:
                          project: Alpha
                          priority: High
                        type: object
                        properties: {}
                        additionalProperties: {}
                      quantity:
                        type: number
                        minimum: 0
                        description: Quantity of items.
                        example: 10
                      amountMinor:
                        type: integer
                        minimum: 0
                        maximum: 9007199254740991
                        description: Amount expressed in the minor unit (e.g., cents).
                        example: 5000
                      currencyCode:
                        type: string
                        minLength: 3
                        maxLength: 3
                        description: ISO 4217 currency code.
                        example: EUR
                      order:
                        type: integer
                        minimum: 0
                        maximum: 9007199254740991
                        description: Order of the resource for sorting purposes.
                        example: 13
                      createdAt:
                        type: string
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                        description: Timestamp when the billable was created.
                        example: '2023-10-05T14:48:00.000Z'
                      updatedAt:
                        type: string
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                        description: Timestamp when the billable was last updated.
                        example: '2023-10-05T14:48:00.000Z'
                    required:
                      - id
                      - invoice
                      - description
                      - quantity
                      - amountMinor
                      - currencyCode
                      - createdAt
                      - updatedAt
                    additionalProperties: false
                    description: Billable resource returned by the API.
                required:
                  - data
                additionalProperties: false
                description: Standard success response payload wrapped in a data property.
        '400':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: Machine-readable error code.
                    example: ValidationError
                  message:
                    type: string
                    description: Human-readable validation error summary.
                  details:
                    type: array
                    items:
                      type: object
                      properties:
                        field:
                          type: string
                          description: Request field that failed validation.
                        message:
                          type: string
                          description: Validation failure message for the field.
                        constraint:
                          type: string
                          description: Validation rule that was violated.
                      required:
                        - field
                        - message
                        - constraint
                      additionalProperties: false
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response returned when request validation fails.
        '401':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    default: Unauthorized
                    description: Machine-readable error code.
                    example: Unauthorized
                    type: string
                  message:
                    default: Unauthorized
                    description: Human-readable error message.
                    example: Unauthorized
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response for requests without valid authentication.
        '403':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    default: Forbidden
                    description: Machine-readable error code.
                    example: Forbidden
                    type: string
                  message:
                    default: Forbidden
                    description: Human-readable error message.
                    example: Forbidden
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response for requests blocked by authorization rules.
        '404':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    default: NotFound
                    description: Machine-readable error code.
                    example: NotFound
                    type: string
                  message:
                    default: Not Found
                    description: Human-readable error message.
                    example: Not Found
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response when the requested resource does not exist.
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````